Unit CRC32___;
{
 
  CRC32___ (TPU7-RM)   (c)2001 NNCI
 
  A low level unit for CRC32 calculation on every kind of data

 -
  Procedures     Arguments
 -
  CRCbuildtable
  CRCstart       <longint/CRC>
  CRCadd         <longint/CRC> <byte/VAL>
  CRCaddbuffer   <longint/CRC> <X> <word/XSIZE>
  CRCend         <longint/CRC>
}

{---------}
 INTERFACE
{---------}

 Procedure CRCbuildtable;
 Procedure CRCstart(Var CRC:LongInt);
 Procedure CRCadd(Var CRC:LongInt; B:Byte);
 Procedure CRCaddbuffer(Var CRC:LongInt; Var BUF; Len:Word);
 Procedure CRCend(Var CRC:LongInt);


{--------------}
 IMPLEMENTATION
{--------------}

 Uses  CRT;
 Const CRCpol=$edb88320;
 Var   CRCtab:Array [$00..$ff] of LongInt;

 Procedure CRCbuildtable;
   Var W0,W1:Byte;
       CRC:LongInt;
   Begin
    FillChar(CRCtab,SizeOf(CRCtab),0);
    For W0:=0 to 255 do begin
     CRC:=LongInt(W0) shl 1;
     For W1:=8 downto 0 do If (CRC and 1)=1 then CRC:=(CRC shr 1) xor CRCpol
                                            else CRC:=CRC shr 1;
     CRCtab[W0]:=CRC;
    end;
   End;

 Procedure CRCadd(Var CRC:LongInt; B:Byte);
   Begin
    CRC:=CRCtab[byte(crc xor longint(b))] xor ((CRC shr 8){ and $00ffffff});
   End;

 Procedure CRCaddbuffer(Var CRC:LongInt; Var BUF; Len:Word);
   Type BUFP=Array [0..65534] of Byte;
   Var SEGM,OFFS,SEGL,OFSL:Word;
       W:Word;
       L:LongInt;
       BP:^BUFP;
       B:Byte;
       CB:^Byte;
   Begin
    If LEN>0 then begin
      BP:=@BUF; CB:=@CRC;
      For W:=0 to LEN-1 do CRC:=CRCtab[CB^ xor BP^[W]] xor (CRC shr 8);
    end;
   End;

 Procedure CRCstart(Var CRC:LongInt);
   Begin
    CRC:=-1;
   End;

 Procedure CRCend(Var CRC:LongInt);
   Begin
    CRC:=CRC xor (-1);
   End;

{---------------}
 Begin
  CRCbuildtable;
 End.
{---------------}