{$F+}
uses Dos,Crt,HexaDeci,Inflate,CRC32___;
const HWUN_Version:word=$030b;
      DateStr:string[10]='2001-10-04';

type tAOB=Array [$0000..$fffe] of byte;

var InflateVars:record
                  F1,F2:file;
                  Buf:^tAOB;
                  BufSize,BufLength:longint;
                  BufPos:longint;
                  F1Pos:longint;
                  F1Length:longint;
                  F2Pos:longint;
                  F2Length:longint;
                  CRC32:longint;
                  InflateResult:longint;
                end;

function InflateReadProc:byte; far;
begin
  InflateReadProc:=InflateVars.Buf^[InflateVars.BufPos];
  inc(InflateVars.F1Pos);
  inc(InflateVars.BufPos);
  if (InflateVars.BufPos=InflateVars.BufLength) then with InflateVars do begin
    BufLength:=F1Length-F1Pos;
    if BufLength>BufSize then BufLength:=BufSize;
    BufPos:=$0000;
    seek(F1,F1POS);
    blockread(F1,Buf^,BufLength);
  end;
end;

const waitstr:array [$00..$03] of char='-\|/';
var waitind:byte;

function InflateFlushProc(W:word):integer; far;
var l:longint;
    c:longint;
begin
  blockwrite(InflateVars.F2,Slide^,w);
  if w>0 then CRCAddBuffer(InflateVars.CRC32,Slide^,w);
  inc(InflateVars.F2Pos,w);
  inc(waitind);
  if waitind mod $02=$00 then begin
    write(waitstr[(waitind div $02) mod $04]);
    l:=trunc(InflateVars.F1Pos/InflateVars.F1Length*100);
    c:=trunc(InflateVars.F1Pos/InflateVars.F1Length*10000) mod 100;
    write(' ',l:3,'.',c div 10,c mod 10,'%'); gotoxy(wherex-9,wherey);
  end;
  InflateFlushProc:=0;
end;

function InitializeInflate(S1,S2:String; Offset:LongInt):byte;
begin
  with InflateVars do begin
    CRCStart(CRC32);
    BufSize:=$f800;
    getmem(Buf,BufSize);
    getmem(Slide,WSize);
    InflateRead:=InflateReadProc;
    InflateFlush:=InflateFlushProc;
    assign(F1,S1);
    assign(F2,S2);
    {$I-} reset(F1,1); {$I+}
    if IoResult=0 then begin
      rewrite(F2,1);
      F1Length:=filesize(F1);
      F1Pos:=Offset;
      F2Length:=0;
      F2Pos:=0;
      BufLength:=F1Length-F1Pos;
      if BufLength>BufSize then BufLength:=BufSize;
      BufPos:=$0000;
      seek(F1,F1Pos);
      blockread(F1,Buf^,BufLength);
      InflateResult:=$00;
    end else begin
      freemem(Slide,WSize);
      freemem(Buf,BufSize);
      InflateResult:=$fd;
      close(F1);
      close(F2);
    end;
  end;
end;

procedure ExecuteInflate;
begin
  with InflateVars do begin
    InflateResult:=InflateRun;
    freemem(Buf,BufSize);
    freemem(Slide,WSize);
    close(F1);
    close(F2);
    F2Length:=F2Pos;
    CRCEnd(CRC32);
  end;
end;

var ArchiveVars:record
      { 00 = ofs in ApprArcOfs, ff = error }
      ApprArcResult:byte;
      ApprArcOfs:longint;
      { 00 = DLL, 01 = Bitmap, 02 = Script, fe = Unknown, ff = Error }
      TestInflateResult:byte;
      RealArcResult:byte;
      { 00 = ofs in RealArcOfs, ff = not found }
      RealArcOfs:longint;
    end;

procedure TestInflate(S1:string; Offset:longint);
const TempName:string[11]='C:\HWUNTMP0';
const BufferSize:word=$8000;
var TempFile:file;
    Buffer:^tAOB;
    Pos,Post:longint;
    Test:boolean;
begin
  with InflateVars do begin
    InitializeInflate(S1,TempName,Offset);
    if InflateResult=0 then ExecuteInflate;
    if InflateResult<>0 then ArchiveVars.TestInflateResult:=$ff else begin
      assign(TempFile,TempName);
      reset(TempFile,1);
      getmem(Buffer,BufferSize);
      fillchar(Buffer^,BufferSize,$ff);
      if filesize(TempFile)>BufferSize then blockread(TempFile,Buffer^,BufferSize)
                                       else blockread(TempFile,Buffer^,filesize(TempFile));
      { Test if it is a bitmap file (splashscreen) by checking dimensions
        for being lower than 16 million pixels and checking palette entries
        to be valid (every fourth byte in palette is unused and set to 00h }
      Test:=TRUE;
      for Pos:=$00 to $17 do Test:=Test and (Buffer^[Pos*$04+$03]=$00);
      if Test then ArchiveVars.TestInflateResult:=$01 else begin
        { Test if it is a DLL file (wise????.dll) by "MZ"-signature check }
        Test:=TRUE;
        Test:=Test and (Buffer^[0]=$4d{"M"});
        Test:=Test and (Buffer^[1]=$5a{"Z"});
        if Test then ArchiveVars.TestInflateResult:=$00 else begin
          { Test if it is a WISE script file by searching for the first
            file being installed on a variable path like %MAINDIR%\????,
            by checking for one "%" and one "%\" }
          Test:=FALSE;
          Pos:=$00;
          while (Pos<BufferSize) and (not Test) do begin
            inc(Pos);
            Test:=TRUE;
            if Test then Test:=Buffer^[Pos+$00]=$25{"%"};
            if Test then Test:=Buffer^[Pos+$01]<>$5c{"\"};
            if Test then begin
              Post:=$01;
              while (Post+Pos<BufferSize) and (Buffer^[Pos+Post]<>$25) and (Post<$10) do inc(Post);
              Test:=(Post<$10) and (Buffer^[Pos+Post+$01]=$5c{"\"});
            end;
          end;
          if Test then ArchiveVars.TestInflateResult:=$02 else ArchiveVars.TestInflateResult:=$fe;
        end;
      end;
      close(TempFile);
      erase(TempFile);
      freemem(Buffer,BufferSize);
    end;
  end;
end;

procedure ApprArc(S1:string);
const Start:longint=$00002800;
      BufferSize:word=$c000;
var F:file;
    FS:longint;
    Buffer:^tAOB;
    BufferLen:longint;
    Pos,Post,Avg,Zero:longint;
    Test1,Test2:boolean;
begin
  assign(F,S1);
  {$I-} reset(F,1); {$I+}
  if IoResult<>0 then ArchiveVars.ApprArcResult:=$ff else begin
    FS:=filesize(F);
    getmem(Buffer,BufferSize);
    fillchar(Buffer^,BufferSize,$00);
    if FS<Start+$800 then ArchiveVars.ApprArcResult:=$ff else begin
      ArchiveVars.ApprArcResult:=$ff;
      seek(F,Start);
      if FS-Start<BufferSize then BufferLen:=FS-Start else BufferLen:=BufferSize;
      blockread(F,Buffer^,BufferLen);
      Test1:=FALSE;
      Test2:=Test1;
      for Pos:=$0000 to BufferLen-$0801 do begin
        Avg:=$00;
        Zero:=Avg;
        for Post:=$0000 to $07ff do Avg:=Avg+Buffer^[Pos+Post];
        for Post:=$0000 to $007f do if Buffer^[Pos+Post]=$00 then inc(Zero);
        Avg:=Avg shr $0b;
        if (not Test1) then Test1:=(not Test2) and (Avg<$40);
        if (not Test2) then Test2:=(Test1) and (Zero<$02) and (Avg>$5f) and (Avg<$a1);
        if Test2 then ArchiveVars.ApprArcOfs:=Pos+Start;
        if Test2 then ArchiveVars.ApprArcResult:=$00;
        if Test2 then Pos:=BufferLen-$0801;
      end;
    end;
    freemem(Buffer,BufferSize);
    close(F);
  end;
end;

procedure RealArc(S1:string);
var Pos:longint;
begin
  with ArchiveVars do begin
    write('  Calculating approximated packed data offset ..................... ');
    ApprArc(S1);
    RealArcResult:=$ff;
    if ApprArcResult=$00 then begin
      writeln('$',Hexa(ApprArcOfs,8));
      write('  Calculating exact packed data offset ............................ ');
      for Pos:=$0000 to $03ff do begin
        TestInflate(S1,ApprArcOfs+Pos);
        if TestInflateResult<$fe then begin
          RealArcResult:=TestInflateResult;
          RealArcOfs:=Pos+ApprArcOfs;
          Pos:=$03ff;
        end;
      end;
      if RealArcResult=$ff then writeln('failed!') else writeln('$',Hexa(RealArcOfs,8));
    end else writeln('failed!');
  end;
end;

procedure HWUNTitle;
var Pos:byte;
    v:word;
begin
  for Pos:=$00 to $4e do write(''); writeln;
  write  (' HWUN v');
  v:=HWUN_Version shr $0c;
  write  (hexa(v,1),'.');
  v:=HWUN_Version and $fff;
  write  (hexa(v,3));
  writeln(' (Heuristic Wise UNpacker, ',DateStr,')  (c) by Jgermeister Markus');
  for Pos:=$00 to $4e do write(''); writeln;
end;

procedure IncreaseFileName(var FileName:string);
var b:byte;
begin
  b:=byte(FileName[0]);
  while (FileName[b]='9') do begin
    FileName[b]:='0';
    dec(b);
  end;
  inc(FileName[b]);
end;

function ReadLongInt(S1:string; Offset:longint):longint;
var F:file;
    L:longint;
begin
  assign(F,S1);
  reset(F,1);
  seek(F,Offset);
  blockread(F,L,4);
  close(F);
  ReadLongInt:=L;
end;

procedure ExtractFiles(S1:string);
var FileName:string;
    FilePos:longint;
    Pos:longint;
    CSize,USize:longint;
    Enough:boolean;
    DumpFile:file;
begin
  RealArc(S1);
  if ArchiveVars.RealArcResult<$ff then begin
    FileName:='WISE0000';
    assign(DumpFile,FileName);
    rewrite(DumpFile,1);
    FilePos:=ArchiveVars.RealArcOfs;
    Enough:=FALSE;
    Repeat
      IncreaseFileName(FileName);
      InitializeInflate(S1,FileName,FilePos);
      if InflateVars.InflateResult=$00 then begin
        write('  Expanding ',FileName,', offset $',hexa(FilePos,8),', ');
        ExecuteInflate;
        if InflateVars.InflateResult=$00 then begin
          blockwrite(DumpFile,FileName[1],8);
          blockwrite(DumpFile,FilePos,4);
          writeln('crc32 $',hexa(InflateVars.CRC32,8),', filelength $',hexa(InflateVars.F2Length,8));
          FilePos:=InflateVars.F1Pos;
          Enough:=TRUE;
          Pos:=$0010;
          if FilePos+$04+Pos>InflateVars.F1Length then Pos:=InflateVars.F1Length-FilePos-$04;
          while (Enough) and (Pos>-$0100) do begin
            if ReadLongInt(S1,FilePos+Pos)=InflateVars.CRC32 then Enough:=FALSE;
            Dec(Pos);
          end;
          if (Enough) then writeln('  Could not find matching CRC32! Maybe archive is in PKZIP format?')
                      else begin
                        FilePos:=FilePos+Pos+$05;
                        blockwrite(DumpFile,FilePos,4);
                      end;
        end else begin
          Enough:=TRUE;
          writeln('possible extra data at archive end');
          erase(InflateVars.F2);
          writeln('  Archive end reached. All files extracted successfully!');
        end;
        if (not Enough) and (FilePos+$10+Pos>=InflateVars.F1Length) then begin
          Enough:=TRUE;
          FilePos:=InflateVars.F1Length;
          writeln('  Archive end reached. All files extracted successfully!');
        end;
      end else writeln('  Could not inflate next file! Is archive corrupt or incomplete?');
    Until Enough;
    close(DumpFile);
  end else writeln('  File does not seem to contain a WISE archive - try Veit''s E_WISE!');
end;

function W95MkDir(S:string):word;
var seg1,ofs1:word;
    res:word;
begin
  S:=S+#0;
  seg1:=seg(S[1]);
  ofs1:=ofs(S[1]);
  asm
    push ds
    mov ax,$7139
    mov dx,seg1
    mov ds,dx
    mov dx,ofs1
    int 21h
    jc @error
    mov ax,$0000
   @error:
    mov res,ax
    pop ds
  end;
  W95MkDir:=res;
end;

function W95Rename(S1,S2:string):word;
var seg1,ofs1,seg2,ofs2,res:word;
begin
  S1:=S1+#0;
  S2:=S2+#0;
  seg1:=seg(S1[1]);
  ofs1:=ofs(S1[1]);
  seg2:=seg(S2[1]);
  ofs2:=ofs(S2[1]);
  asm
    push ds
    push di
    mov ax,$7156
    mov dx,seg2
    mov es,dx
    mov dx,ofs2
    mov di,dx
    mov dx,seg1
    mov ds,dx
    mov dx,ofs1
    int 21h
    jc @error
    mov ax,$0000
   @error:
    mov res,ax
    pop di
    pop ds
  end;
  W95Rename:=res;
end;

function W95SetTimeDate(S1:string; Date,Time:word):word;
var seg1,ofs1,res:word;
begin
  S1:=S1+#0;
  seg1:=seg(S1[1]);
  ofs1:=ofs(S1[1]);
  asm
    push ds
    push di
    mov ax,$7143
    mov dx,seg1
    mov ds,dx
    mov dx,ofs1
    mov bl,03h
    mov cx,Date
    mov di,cx
    mov cx,Time
    mov bl,07h
    int 21h
    mov ax,$7143
    mov dx,seg1
    mov ds,dx
    mov dx,ofs1
    mov bl,03h
    mov cx,Date
    mov di,cx
    mov cx,Time
    mov bl,03h
    int 21h
    jc @error
    mov ax,$0000
   @error:
    mov res,ax
    pop di
    pop ds
  end;
  W95SetTimeDate:=res;
end;

procedure GenerateRenamer;
var DumpFile,ScriptFile:file;
    FileName,NewName,ScriptName:string;
    TempStart,TempLen,TempEnd,FileStart,FileLen,FileEnd:longint;
    ArcLength,ArcStart,ScriptSize:longint;
    FirstFound:boolean;
    Test:boolean;
    Error:boolean;
    Buffer:^tAOB;
    Pos,Post,Postt:longint;
    BufferSize:longint;
    Minimum:longint;
    Time,Date:word;
    ControlByte:byte;
    B1,B2:byte;
    Result:word;
    FixedName:string;
begin
  assign(DumpFile,'WISE0000');
 {$I-} reset(DumpFile,1); {$I+}
  if IoResult<>0 then Halt(1);
  FileName[0]:=#8;
  ScriptName[0]:=#8;
  Test:=FALSE;
  repeat
    blockread(DumpFile,ScriptName[1],8);
    blockread(DumpFile,FileStart,4);
    blockread(DumpFile,FileEnd,4);
    assign(ScriptFile,ScriptName);
    reset(ScriptFile,1);
    BufferSize:=filesize(ScriptFile);
    if BufferSize>$8000 then BufferSize:=$8000;
    getmem(Buffer,BufferSize);
    blockread(ScriptFile,Buffer^,BufferSize);
    close(ScriptFile);
    Pos:=$00;
    while (Pos<BufferSize) and (not Test) do begin
      inc(Pos);
      Test:=TRUE;
      if Test then Test:=Buffer^[Pos+$00]=$25{"%"};
      if Test then Test:=Buffer^[Pos+$01]<>$5c{"\"};
      if Test then begin
        Post:=$01;
        while (Post+Pos<BufferSize) and (Buffer^[Pos+Post]<>$25) and (Post<$10) do inc(Post);
        Test:=(Post<$10) and (Buffer^[Pos+Post+$01]=$5c{"\"});
      end;
    end;
    freemem(Buffer,BufferSize);
  until eof(DumpFile) or Test;
  write('  Script is ',ScriptName,', renaming and moving files (may take a while!) ');

  seek(DumpFile,0);
  BufferSize:=filesize(DumpFile);
  blockread(DumpFile,Buffer^,BufferSize);
  close(DumpFile);

{ Dumpfile read to Buffer^, correct ScriptFile opened }

  reset(ScriptFile,1);
  Pos:=$00;
  NewName:='';
  Minimum:=$00000000;
  FileName:='xxxxxxxx';
  FirstFound:=FALSE;
  while Pos+$02<fileSize(ScriptFile) do begin
    seek(ScriptFile,Pos);
    blockread(ScriptFile,ControlByte,1);
    if ControlByte=$25 then begin
      blockread(ScriptFile,ControlByte,1);
      if (ControlByte<>$5c) then begin
        inc(waitind);
        write(waitstr[(waitind div $02) mod $04]); gotoxy(wherex-1,wherey);
        NewName:='';
        Test:=FALSE;
        repeat
          NewName:=NewName+chr(ControlByte);
          blockread(ScriptFile,ControlByte,1);
          if copy(NewName,length(NewName)-1,2)='%\' then Test:=TRUE;
        until (ControlByte in [$7f,$00]) or (filepos(ScriptFile)=filesize(ScriptFile));
        if (Test) and (Pos>=$28) then begin
          seek(ScriptFile,Pos-$28);
          blockread(ScriptFile,TempStart,4);
          blockread(ScriptFile,TempEnd,4);
          blockread(ScriptFile,Date,2);
          blockread(ScriptFile,Time,2);
          TempLen:=TempEnd-TempStart;
          if (TempStart-Minimum<$100000) and (TempStart<TempEnd) and (TempStart>=Minimum) then begin
            if not FirstFound then begin
              Post:=$0000;
              Error:=FALSE;
              repeat
                move(Buffer^[Post+$8],FileStart,4);
                move(Buffer^[Post+$c],FileEnd,4);
                FileLen:=FileEnd-FileStart;
                inc(Post,$10);
              until (FileLen=TempLen) or (Post>=BufferSize);
              if (Post<BufferSize) and (NewName[byte(NewName[0])]<>'%') then begin
                FirstFound:=TRUE;
                ArcStart:=FileStart-TempStart;
                move(Buffer^[Post-$10],FileName[1],8);
              end else FirstFound:=FALSE;
            end else begin
              repeat
                move(Buffer^[Post+$8],FileStart,4);
                move(Buffer^[Post+$c],FileEnd,4);
                move(Buffer^[Post+$0],FileName[1],8);
                FileLen:=FileEnd-FileStart;
                inc(Post,$10);
              until ((FileStart=TempStart+ArcStart) and (FileEnd=TempEnd+ArcStart)) or (Post>=BufferSize);
              Error:=(FileStart<>TempStart+ArcStart) or (FileEnd<>TempEnd+ArcStart);
            end;
            if (FirstFound) and (not Error) then begin
              FixedName:='';
              for ControlByte:=1 to length(NewName) do begin
                if NewName[ControlByte]='\' then W95MkDir(FixedName);
                if NewName[ControlByte]<>'%' then FixedName:=FixedName+NewName[ControlByte];
              end;
{              writeln;
              write(Date and $1f:2,'.',Date shr $05 and $f:2,'.',Date shr $09+1980);
              write(' ',Time shr $0b:2,':',Time shr $05 and $3f:2,'.',Time and $1f:2);
              write(' ',FileName,' -> ',FixedName);}
              repeat
                Result:=W95Rename(FileName,FixedName);
                if Result=$0000 then begin
                  W95SetTimeDate(FixedName,Date,Time);
                end;
                NewName:='';
                ControlByte:=length(FixedName);
                while (FixedName[ControlByte]<>'.') and (ControlByte>$00) do dec(ControlByte);
                if ControlByte=$01 then FixedName:=FixedName+'.!' else begin
                  FixedName:=copy(FixedName,1,ControlByte)+'!.'+copy(FixedName,ControlByte+1,length(FixedName)-ControlByte);
                end;
              until (Result=$0000) or (length(FixedName)>$fb);
              Minimum:=TempEnd;
            end;
          end;
        end;
      end;
    end;
    inc(Pos);
  end;

  close(ScriptFile);
  writeln('done!');
end;

function GetWindowsVersion:word;
var w:word;
begin
  asm
    mov ax,$160a
    mov bx,$0000
    int $2f
    cmp ax,$0000
    je @equal
    mov bx,$0000
    @equal:
    mov w,bx
  end;
  GetWindowsVersion:=w;
end;

Function GetSFN(S1:String):String;
Var BUF1,BUF2:Array[0..511] of Byte;
    S2:String;
    NUM,B,POS:Byte;
    SEG1,SEG2,OFS1,OFS2:Word;
Begin
 SEG1:=Seg(BUF1);
 OFS1:=Ofs(BUF1);
 SEG2:=Seg(BUF2);
 OFS2:=Ofs(BUF2);
 NUM:=0;
 For B:=1 to Length(S1) do begin
  BUF1[B-1]:=Byte(S1[B]);
  If S1[B]='\' then Inc(NUM);
 end;
 BUF1[Length(S1)]:=0;
 FillChar(BUF2,512,0);
 ASM
  push ds
  push si
  push es
  push di
  mov ax,SEG1
  mov ds,ax
  mov si,OFS1
  mov ax,SEG2
  mov es,ax
  mov di,OFS2
  mov ax,7160h
  mov cx,0001h
  int 21h
  pop di
  pop es
  pop si
  pop ds
 END;
 S2:='';
 B:=0;
 While BUF2[B]<>0 do begin
  S2:=S2+Chr(BUF2[B]);
  Inc(B);
 end;
 GetSFN:=Copy(S2,1,Length(S2));
End;

var Win:word;
    EXEstring:string;
    b:byte;
begin
  Win:=GetWindowsVersion;
  FileMode:=0;
  HWUNTitle;
  if Win<$0400 then begin
    writeln('  Program cannot run without Windows 95 or later environment!');
    halt(255);
  end;
  if paramcount=0 then begin
    writeln(' Usage: HWUN <wisefile.exe>');
    writeln;
    writeln(' Contact: jaegermeister.markus@gmx.de, http://jmeister.cjb.net');
    writeln;
    writeln(' History: 2001-10-04 / v0.30b');
    writeln('            - date and time are resolved and files are stamped now');
    writeln('            - Win9x detection for long filename functions');
    writeln('            - bugfix: file end of scriptfile now respected more carefully');
    writeln('            - bugfix: HWUN now accepts long filenames as parameter');
    writeln('          2001-09-26 / v0.20b (named v0.15b incorrectly in the title)');
    writeln('            - better heuristic');
    writeln('            - file renaming now done with Win9x Int 21h-LFN-functions');
    writeln('            - bugfix: crashed if heuristic was not accurate enough');
    writeln('            - bugfix: crashed due to wrong scriptsize detection');
    writeln('            - bugfix: hang if first possible found filename did not exist');
    writeln('            - bugfix: now detects additional data at archive end');
    writeln('            - bugfix: file renaming routines didn''t work by incident');
  end else begin
    ExeString:=paramstr(1);
    if ExeString[1]='"' then begin
      b:=2;
      while ExeString[length(ExeString)]<>'"' do begin
        if paramstr(b)='' then ExeString:=ExeString+'"' else ExeString:=ExeString+' '+paramstr(b);
        inc(b);
      end;
      ExeString:=copy(ExeString,2,length(ExeString)-2);
    end;
    ExeString:=GetSFN(ExeString);
    if Win>=$0400 then writeln('  Detected Windows version ',Win shr $08,'.',Win and $ff,' with LFN support');
    if ExeString='' then begin
      writeln('  File passed by parameter was not found!');
      halt(254);
    end;
    ExtractFiles(ExeString);
    GenerateRenamer;
  end;
end.